SystemOrganization addCategory: #'OCMS-Interface'!

WAComponent subclass: #CommentAddView
	instanceVariableNames: 'comment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!CommentAddView methodsFor: 'initialization' stamp: 'has 6/29/2013 20:14'!
initialize
	super initialize.
	comment := Comment new.! !

!CommentAddView methodsFor: 'rendering' stamp: 'has 6/29/2013 20:20'!
renderButtonsOn: html
	html div: [
		html submitButton
			callback: [self answer: comment];
			with: 'Confirm'.
		html cancelButton
			callback: [self answer: nil];
			with: 'Cancel'.
	].! !

!CommentAddView methodsFor: 'rendering' stamp: 'has 6/29/2013 20:18'!
renderContentOn: html
	html heading level: 1; with: 'New comment'.
	html text: 'Type your registration Info'. 
	
	html form: [
		self
			renderTextOn: html;
			renderButtonsOn: html;  
			yourself.  
	].  ! !

!CommentAddView methodsFor: 'rendering' stamp: 'has 7/1/2013 16:57'!
renderTextOn: html
	html div: [
		html label: 'Your comment'.
		html textArea
			callback: [:value | comment text: value.
							comment dateAndTime: DateAndTime now.
							comment user: self session user.
						].
	].! !

WAComponent subclass: #ConfirmView
	instanceVariableNames: 'question'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!ConfirmView class methodsFor: 'instance creation' stamp: 'oda 7/1/2013 01:05'!
on: aQuestion
	^self basicNew
		initialize: aQuestion;
		yourself.! !

!ConfirmView methodsFor: 'initialize-release' stamp: 'oda 7/1/2013 01:49'!
initialize: aQuestion
	self initialize.  
	question := aQuestion.  ! !

!ConfirmView methodsFor: 'rendering' stamp: 'oda 7/1/2013 01:06'!
renderButtonsOn: html
	html div: [
		html submitButton
			callback: [self answer: true];
			with: 'Confirm'.
		html cancelButton
			callback: [self answer: false];
			with: 'Cancel'.
	].! !

!ConfirmView methodsFor: 'rendering' stamp: 'oda 7/1/2013 01:18'!
renderContentOn: html
	html paragraph: question.
	html form: [
		self renderButtonsOn: html.
	]! !

WAComponent subclass: #CourseAddView
	instanceVariableNames: 'course'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!CourseAddView methodsFor: 'initialize-release' stamp: 'oda 7/1/2013 01:49'!
initialize
	super initialize.
	course := Course new.! !

!CourseAddView methodsFor: 'rendering' stamp: 'oda 6/30/2013 17:36'!
renderButtonsOn: html
	html div: [
		html submitButton
			callback: [self answer: course];
			with: 'Confirm'.
		html cancelButton
			callback: [self answer: nil];
			with: 'Cancel'.
	].! !

!CourseAddView methodsFor: 'rendering' stamp: 'oda 6/30/2013 17:32'!
renderCategoryOn: html
	html div: [
		html text: 'Category: [TODO]'.
	]! !

!CourseAddView methodsFor: 'rendering' stamp: 'oda 6/30/2013 21:01'!
renderContentOn: html
	html heading level: 1; with: 'New course'.
	html text: 'Type the course''s Info'. 
	
	html form: [
		self
			renderDescriptionOn: html;
			"renderCategoryOn: html;"
			renderButtonsOn: html;  
			yourself.  
	].  ! !

!CourseAddView methodsFor: 'rendering' stamp: 'oda 6/30/2013 17:31'!
renderDescriptionOn: html
	html div: [
		html label: 'Name:'.
		html textInput
			callback: [:value | course description: value].
	]! !

WAComponent subclass: #CourseEditView
	instanceVariableNames: 'course'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!CourseEditView class methodsFor: 'instance creation' stamp: 'oda 7/1/2013 02:00'!
on: aCourse
	^self basicNew
		initialize: aCourse;
		yourself.! !

!CourseEditView methodsFor: 'initialize-release' stamp: 'oda 7/1/2013 02:21'!
initialize: aCourse
	self initialize.  
	course := aCourse.
.! !

!CourseEditView methodsFor: 'rendering' stamp: 'oda 7/1/2013 01:53'!
renderButtonsOn: html
	html div: [
		html submitButton
			callback: [self answer: course];
			with: 'Confirm'.
		html cancelButton
			callback: [self answer: nil];
			with: 'Cancel'.
	].! !

!CourseEditView methodsFor: 'rendering' stamp: 'oda 7/1/2013 02:49'!
renderContentOn: html
	html heading level: 1; with: 'Edit course ', course description.
	html paragraph: 'Type the course''s Info'. 
	
	html form: [
		self
			renderDescriptionOn: html;
			renderButtonsOn: html;  
			yourself.  
	].  ! !

!CourseEditView methodsFor: 'rendering' stamp: 'oda 7/1/2013 02:37'!
renderDescriptionOn: html
	html div: [
		html label: 'Name:'.
		html text: course description.
	]! !

WAComponent subclass: #CourseListView
	instanceVariableNames: 'courseCollection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!CourseListView methodsFor: 'updating' stamp: 'oda 7/1/2013 16:50'!
addCourse
	| component answer |
	component := CourseAddView new.
	answer := self call: component.

	(answer notNil)
		ifTrue: [	
				[
					(CourseManager new) includeCourse: answer.
					self inform: ('Course successfully added.').
				]  
				on: Error
				do: [:sig |
					OCMSDB session abort.
					self inform: ('Failed due to ', sig asString)
				].
		].
! !

!CourseListView methodsFor: 'updating' stamp: 'oda 7/1/2013 16:50'!
deleteCourse: aCourse
	| component answer courseManager |
	component := ConfirmView on: 'Are you sure you want to delete this course?'.
	answer := self call: component.

	(answer)
		ifTrue: [	
				courseManager := CourseManager new.
				[
					courseManager removeCourse: aCourse.
					self inform: ('Course successfully deleted.').
				]  
				on: Error
				do: [:sig |
					OCMSDB session abort.
					self inform: ('Failed it due to ', sig asString)
				].
		].
! !

!CourseListView methodsFor: 'updating' stamp: 'oda 7/1/2013 16:50'!
editCourse: aCourse
	| component answer |
	component := CourseEditView on: aCourse.
	answer := self call: component.

	(answer notNil)
		ifTrue: [	
				[
					(CourseManager new) updateCourse: answer.
					self inform: ('Course successfully updated.').
				]  
				on: Error
				do: [:sig |
					OCMSDB session abort.
					self inform: ('Failed due to ', sig asString)
				].
		].
! !

!CourseListView methodsFor: 'initialize-release' stamp: 'oda 7/2/2013 15:13'!
initialize
	super initialize.
	courseCollection := OrderedCollection new.! !

!CourseListView methodsFor: 'rendering' stamp: 'oda 6/30/2013 17:12'!
renderAddAnchorOn: html
	html anchor
		callback: [self addCourse];
		with: 'New course'.
	html break.! !

!CourseListView methodsFor: 'rendering' stamp: 'oda 7/1/2013 18:27'!
renderContentOn: html
	html heading
		level: 1;
		with: 'Courses'.
	self session user isAdmin ifTrue: [
		html paragraph: [self renderAddAnchorOn: html.].
	].
	self renderItemsOn: html.  ! !

!CourseListView methodsFor: 'rendering' stamp: 'oda 7/1/2013 17:54'!
renderItem: aCourse on: html
	html tableRow: [
		html tableData: [
			html anchor
				callback: [self call: (GroupListView on: aCourse)];
				with: [html strong:aCourse description].
		].
		html tableData: [
			self session user isAdmin ifTrue: [
				html anchor
					callback: [self deleteCourse: aCourse];
					with: 'Delete'.
			]
		]
	]! !

!CourseListView methodsFor: 'rendering' stamp: 'has 7/2/2013 13:15'!
renderItemsOn: html
	| courseList |
	courseList := Courses getAll.
	(courseCollection isEmpty)
		ifTrue:[courseCollection := courseList].
	html anchor
		callback:[self sortCoursesByName:courseCollection.];
		with:'Sort by Name'.
	html break.
	html break.
	html table: [
		courseCollection do: [:each | self renderItem: each on: html].
	]! !

!CourseListView methodsFor: 'updating' stamp: 'has 7/2/2013 13:15'!
sortCoursesByName: aCourseCollection
		
	| component |
	component := self.
	[
		courseCollection:= (CourseManager new) sortByName: aCourseCollection.
	]  
	on: Error
	do: [:sig |
		self inform: ('Failed it due to ', sig asString)
	].! !

WAComponent subclass: #CoursewareAddView
	instanceVariableNames: 'courseware authorValue authorList tagValue courseValue courseList tagList file fileSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!CoursewareAddView methodsFor: 'updating' stamp: 'has 7/1/2013 12:30'!
addAuthor: anAuthor
	| component authorList |
	component  := self.
	authorList := self courseware author.
	[
		(courseware authorExists: anAuthor)
			ifFalse:[	authorList add: anAuthor.
					courseware author: authorList.
					self inform: ('The author was successfully registered.').]
			ifTrue:[self inform: ('The author already exists in this courseware.').].
	]
	on: Error
		do: [:sig | self inform: ('Could not add the tag due to ', sig asString)].! !

!CoursewareAddView methodsFor: 'updating' stamp: 'has 7/1/2013 12:27'!
addAuthorNew: anAuthor
	| component authorList authorTemp |
	authorTemp := anAuthor trimBoth.
	component  := self.
	authorList := self courseware author.
	[
		((authorTemp = ''))
			ifFalse:[
					(courseware authorExists: authorTemp)
						ifFalse:[	authorList add: authorTemp.
								courseware author: authorList.
								self inform: ('The author was successfully registered.').]
						ifTrue:[self inform: ('The author already exists in this courseware.').].
					]
			ifTrue:[self inform: ('Null authors cannot be added.')]
	]
	on: Error
		do: [:sig | self inform: ('Could not add the tag due to ', sig asString)].! !

!CoursewareAddView methodsFor: 'updating' stamp: 'has 7/1/2013 10:37'!
addCourse: aCourse
	| component courseList |
	component  := self.
	courseList := self courseware course.
	[
		(courseware courseExists: aCourse)
			ifFalse:[	courseList add: aCourse.
					courseware course: courseList.
					self inform: ('The course was successfully registered.').]
			ifTrue:[self inform: ('The course already exists in this courseware.').].
	]
	on: Error
		do: [:sig | self inform: ('Could not add the course due to ', sig asString)].! !

!CoursewareAddView methodsFor: 'updating' stamp: 'has 7/1/2013 11:34'!
addOwner
	courseware owner: self session user.! !

!CoursewareAddView methodsFor: 'updating' stamp: 'has 7/1/2013 12:31'!
addTag: aTag
	| component newTag tagList tagManager |
	component  := self.
	tagList := self courseware tag.
	tagManager := TagManager new.
	newTag:= Tag new.
	[
		(Tags labelExists: aTag)
			ifFalse:[tagManager includeTag: aTag].
				(courseware tagExists: aTag)
				ifFalse:[	newTag label: aTag.
						tagList add: newTag.
						courseware tag: tagList.
						self inform: ('The tag was successfully registered.').]
				ifTrue:[self inform: ('The tag already exists in this courseware.').].
	]
	on: Error
		do: [:sig | self inform: ('Could not add the tag due to ', sig asString)].! !

!CoursewareAddView methodsFor: 'updating' stamp: 'has 7/1/2013 12:28'!
addTagNew: aTag
	| component newTag tagList tagManager tagTemp |
	tagTemp := aTag trimBoth.
	component  := self.
	tagList := self courseware tag.
	tagManager := TagManager new.
	newTag:= Tag new.
	[
		((tagTemp = ''))
			ifFalse:[
						(Tags labelExists: tagTemp)
							ifFalse:[tagManager includeTag: tagTemp].
						(courseware tagExists: tagTemp)
							ifFalse:[	newTag label: tagTemp.
									tagList add: newTag.
									courseware tag: tagList.
									self inform: ('The tag was successfully registered.').]
							ifTrue:[self inform: ('The tag already exists in this courseware.').].
					]
			ifTrue:[self inform: ('Null tags cannot be added.')]
	]
	on: Error
		do: [:sig | self inform: ('Could not add the tag due to ', sig asString)].! !

!CoursewareAddView methodsFor: 'accessing' stamp: 'has 7/1/2013 20:55'!
courseValue: aCourse
	courseValue:= aCourse.
! !

!CoursewareAddView methodsFor: 'accessing' stamp: 'has 7/1/2013 10:37'!
courseware
	^courseware! !

!CoursewareAddView methodsFor: 'accessing' stamp: 'has 7/1/2013 10:37'!
courseware: aCourseware
	courseware:=aCourseware.! !

!CoursewareAddView methodsFor: 'initialization' stamp: 'has 7/1/2013 13:26'!
initialize
	super initialize.
	courseware := Courseware new.
	courseList:= (Course new) searchAllCourses.
	tagList:= (TagManager new) searchAllTags.
	authorList:= (CoursewareManager new) searchAllAuthors.! !

!CoursewareAddView methodsFor: 'rendering' stamp: 'has 7/2/2013 02:51'!
renderAuthorsAddNewOn: html
	(html tableHeading) align:'left'; with: 'Add Authors:'.
	html tableData: [html textInput
						callback:[:value | authorValue := value].
					html space.
					html button
						callback: [self addAuthorNew: authorValue ];
						with: 'Add'.].! !

!CoursewareAddView methodsFor: 'rendering' stamp: 'has 7/2/2013 02:59'!
renderAuthorsAddOn: html
	(html tableHeading) align:'left'; with: 'Add Authors:'.
	html tableData: [(html select) 
            				list: authorList;
						selected: authorValue;
						labels:[:ea | ea];
						callback:[:value | (value trimBoth ~= '') ifTrue:[courseware author add: value]].
					].! !

!CoursewareAddView methodsFor: 'rendering' stamp: 'has 7/1/2013 10:37'!
renderAuthorsOn: html
	html div: [
		html label: 'Author:'.
		html label: courseware authorString.
	].! !

!CoursewareAddView methodsFor: 'rendering' stamp: 'has 7/2/2013 02:57'!
renderButtonsOn: html
	(html tableHeading) align:'left'; with: 'Submit:'.
	html tableData: [html submitButton
			callback: [	self addOwner.
						self answer: courseware];
			with: 'Save'.
		html cancelButton
			callback: [self answer: nil];
			with: 'Cancel'.].! !

!CoursewareAddView methodsFor: 'rendering' stamp: 'has 7/2/2013 02:52'!
renderCataloguingDataOn: html
	(html tableHeading) align:'left'; with: 'Cataloguing data:'.
	html tableData: [html textArea
						callback: [:value | courseware cataloguingData: value].].! !

!CoursewareAddView methodsFor: 'rendering' stamp: 'has 7/2/2013 02:31'!
renderContentOn: html
	html heading level: 1; with: 'New Courseware'.
	html text: 'Type the courseware''s info'. 
	html break.
	html text: 'First upload the file of courseware'.
	
	html form: [
	html table: [
		html tableRow: [self renderUploadOn: html.].
		html tableRow: [self renderTitleOn: html.].
		html tableRow: [self renderSummaryOn: html.].
		html tableRow: [self renderDescriptionOn: html.].
		html tableRow: [self renderCoursewareTypeOn: html.].
		html tableRow: [self renderReferenceOn: html.].
		html tableRow: [self "renderTagsOn: html;"
							renderTagsAddOn: html.].
		html tableRow: [self "renderTagsAddNewOn: html;"
							"renderCoursesOn: html;"
							renderCoursesAddOn: html.].
		html tableRow: [self "renderAuthorsOn: html;"
							renderAuthorsAddOn: html.].
		html tableRow: [self "renderAuthorsAddNewOn: html;"
							renderCataloguingDataOn: html.].
		html tableRow: [self renderLicenseTypeOn: html.].
		html tableRow: [self "renderEnabledOn: html;"
							renderFileOn: html.].
		html tableRow: [self renderSizeOn: html.].
		html tableRow: [self renderButtonsOn: html.].
		self yourself.  
	]. ].! !

!CoursewareAddView methodsFor: 'rendering' stamp: 'has 7/2/2013 02:46'!
renderCoursesAddOn: html
	(html tableHeading) align:'left'; with: 'Add Course:'.
	html tableData: [(html select) 
            	list: courseList;
			selected: courseValue;
			labels:[:ea | ea description];
			callback:[:value | courseValue := value].].! !

!CoursewareAddView methodsFor: 'rendering' stamp: 'has 7/1/2013 10:37'!
renderCoursesOn: html
	html div: [
		html label: 'Courses:'.
		html label: courseware courseString.
	].! !

!CoursewareAddView methodsFor: 'rendering' stamp: 'has 7/2/2013 02:39'!
renderCoursewareTypeOn: html
	(html tableHeading) align:'left'; with: 'CoursewareType:'.
	html tableData: [ html select 
            				list: CoursewareType coursewareTypeList; 
            				"on: #coursewareType of: self CoursewareType coursewareTypeList;"
						callback: [:value | courseware coursewareType: value].].! !

!CoursewareAddView methodsFor: 'rendering' stamp: 'has 7/2/2013 02:37'!
renderDescriptionOn: html
	(html tableHeading) align:'left'; with: 'Description:'.
		html tableData: [ html textArea 
							callback: [:value | courseware description: value].].! !

!CoursewareAddView methodsFor: 'rendering' stamp: 'has 7/1/2013 11:28'!
renderEnabledOn: html
	| group |
	html div: [
		html label: 'Enabled:'.
		group := html radioGroup.
		group radioButton
			selected: true;
			callback:[self courseware isEnabled:true.].
		html text: 'True'.
		group radioButton
			selected: false;
			callback:[self courseware isEnabled:false.].
		html text: 'False'.
	].! !

!CoursewareAddView methodsFor: 'rendering' stamp: 'has 7/2/2013 02:55'!
renderFileOn: html
	(html tableHeading) align:'left'; with: 'File name:'.
	html tableData: [html label: courseware file.].! !

!CoursewareAddView methodsFor: 'rendering' stamp: 'has 7/2/2013 02:54'!
renderLicenseTypeOn: html
	(html tableHeading) align:'left'; with: 'License:'.
	html tableData: [html select 
			            	list: LicenseType licenseTypeList; 
  				          	"on: #license of: LicenseType licenseTypeList;"
						callback: [:value | courseware license: value].].! !

!CoursewareAddView methodsFor: 'rendering' stamp: 'has 7/2/2013 02:40'!
renderReferenceOn: html
	(html tableHeading) align:'left'; with: 'Reference:'.
	html tableData: [  html textArea
						callback: [:value | courseware reference: value].].! !

!CoursewareAddView methodsFor: 'rendering' stamp: 'has 7/2/2013 02:55'!
renderSizeOn: html
	(html tableHeading) align:'left'; with: 'File size:'.
	html tableData: [html label: (courseware size) asString, ' bytes'.].! !

!CoursewareAddView methodsFor: 'rendering' stamp: 'has 7/2/2013 02:36'!
renderSummaryOn: html
	(html tableHeading) align:'left'; with: 'Summary:'.
		html tableData: [ html textArea 
							callback: [:value | courseware summary: value].].! !

!CoursewareAddView methodsFor: 'rendering' stamp: 'has 7/2/2013 03:00'!
renderTagsAddNewOn: html
	(html tableHeading) align:'left'; with: 'Add Tags:'.
	html tableData: [html textInput
						callback:[:value | tagValue := value].
					html space.
					html button
						callback: [self addTagNew: tagValue ];
					with: 'Add'..].! !

!CoursewareAddView methodsFor: 'rendering' stamp: 'has 7/2/2013 03:02'!
renderTagsAddOn: html
(html tableHeading) align:'left'; with: 'Add Tags:'.
	html tableData: [(html select) 
            	list: tagList;
			selected: tagValue;
			labels:[:ea | ea label];
			callback:[:value | ((value label) trimBoth ~= '') ifTrue:[courseware tag add: value]].]! !

!CoursewareAddView methodsFor: 'rendering' stamp: 'has 7/1/2013 10:37'!
renderTagsOn: html
	html div: [
		html label: 'Tags:'.
		html label: courseware tagString.
	].! !

!CoursewareAddView methodsFor: 'rendering' stamp: 'has 7/1/2013 10:37'!
renderTagsSearchOn: html for: type
	html div: [
		html label: 'Add Tags:'.
		html searchInput
			id: ('inputfield');
			onSearch: (Tags searchTagByLabel: type);
			onKeyUp: (Tags searchTagByLabel: type).
	].! !

!CoursewareAddView methodsFor: 'rendering' stamp: 'has 7/2/2013 02:35'!
renderTitleOn: html
	(html tableHeading) align:'left'; with: 'Title:'.
		html tableData: [ html textArea 
							callback: [:value | courseware title: value].].! !

!CoursewareAddView methodsFor: 'rendering' stamp: 'has 7/2/2013 02:34'!
renderUploadOn: html
	(html tableHeading) align:'left'; with: 'File:'.
	html tableData: [html anchor
						callback: [self uploadFile];
						with: 'Upload courseware'.].! !

!CoursewareAddView methodsFor: 'updating' stamp: 'has 7/1/2013 16:43'!
uploadFile
	| component |
	component  := UploadCourseware new.
	file := self call: component.
	
	[(file fileName ~= '')
		ifTrue: [
				courseware file: file fileName.
				courseware size: file size.
				self inform: ('Your file was successfully uploaded.').
				]
	]  
	on: Error
	do: [:sig | self inform: ('Could not add the file due to ', sig asString)].! !

WAComponent subclass: #CoursewareDetailsView
	instanceVariableNames: 'courseware file score'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!CoursewareDetailsView class methodsFor: 'instance creation' stamp: 'oda 7/1/2013 15:36'!
on: aCourseware
	^self basicNew
		initialize: aCourseware;
		yourself.  ! !

!CoursewareDetailsView methodsFor: 'updating' stamp: 'has 6/29/2013 20:44'!
addComment
	| comment component |
	component  := CommentAddView new.
	comment := self call: component.
	
	(comment isMemberOf: Comment)
		ifTrue: [
				[	
					(CoursewareManager new) includeComment: courseware comment: comment.
					self inform: ('Your comment was successfully registered.').
				]  
				on: Error
				do: [:sig | self inform: ('Could not add the comment due to ', sig asString)].
		].! !

!CoursewareDetailsView methodsFor: 'updating' stamp: 'has 7/2/2013 11:31'!
addRating: aScore
	| component |
	component := self.
	(self session user isNil)
		 ifFalse: [
				[	
					(CoursewareManager new) includeOrUpdateCoursewareScore: courseware ofUser: (self session user) withScore: self score.
					self inform: ('Your rate was successfully registered.').
				]  
				on: Error
				do: [:sig | self inform: ('Could not add your rate due to ', sig asString)].
		].! !

!CoursewareDetailsView methodsFor: 'rendering' stamp: 'has 6/29/2013 15:12'!
back
	self answer.! !

!CoursewareDetailsView methodsFor: 'accessing' stamp: 'has 6/29/2013 15:44'!
courseware
	^courseware.! !

!CoursewareDetailsView methodsFor: 'accessing' stamp: 'has 6/29/2013 15:43'!
courseware: aCourseware
	courseware:= aCourseware.! !

!CoursewareDetailsView methodsFor: 'downloading' stamp: 'has 7/1/2013 07:44'!
downloadFile
	"I get the file of the courseware stored from uploads directory and download to the user"
	| stream content |
	file := WAFile new.
	file fileName: courseware file.

	stream := (StandardFileStream fileNamed: 'uploads/',courseware file).
	content := stream contents.
	stream close.
	file contents: content.
	
	courseware downloadCounter: courseware downloadCounter + 1.
	(CoursewareManager new) updateCourseware: courseware.
	
	self requestContext respond: [ :response |
		response 
            contentType: file contentType;
            document: file rawContents;
		attachmentWithFileName: file fileName ]! !

!CoursewareDetailsView methodsFor: 'initialization' stamp: 'has 7/1/2013 09:05'!
initialize
	super initialize.! !

!CoursewareDetailsView methodsFor: 'initialization' stamp: 'oda 7/1/2013 15:35'!
initialize: aCourseware
	self initialize.
	courseware := aCourseware.! !

!CoursewareDetailsView methodsFor: 'rendering' stamp: 'has 7/2/2013 08:28'!
renderContentOn: html
	"I render the list of coursewares"

	html heading level: 1;
				with: courseware title.
	html space.
	html break.
	html table:[
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Id'.
						html tableData: courseware id.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Description'.
						html tableData: courseware description.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Summary'.
						html tableData: courseware summary.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Courseware type'.
						html tableData: courseware coursewareType.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Owner'.
						html tableData: courseware owner username.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Reference'.
						html tableData: courseware reference.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Tags'.
						html tableData: courseware tagString].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Courses'.
						html tableData: courseware courseString].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Authors'.
						html tableData: courseware authorString.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Created at:'.
						html tableData: courseware creationDateTime asTimeStamp.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Cataloguing data'.
						html tableData: courseware cataloguingData.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'License'.
						html tableData: courseware license asString.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'File name'.
						html tableData: courseware file.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Size'.
						html tableData: (courseware size) asString, ' bytes'.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'No. downloads'.
						html tableData: courseware downloadCounter.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Enabled'.
						html tableData: courseware isEnabled.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Rating score'.
						html tableData: (courseware calculateRatingScore) asString,' by ',(courseware score) size asString,' users'.].
	].
	html break.
	(courseware isEnabled)
		ifTrue:[(courseware size > 0)
			ifTrue:[	html anchor
						callback: [self downloadFile];
						with: 'Download'.
					html break.]
			ifFalse:[ html text: 'No file to download'.
					html break.	].]
		ifFalse:[html text: 'Disabled to download'.
					html break.].
	html break.
	self renderRatingOn: html.
	html break.
	html anchor
		callback: [self addComment];
		with: 'Add a comment'.
	html break.
	html heading level: 3;
		with: 'Comments'.
	html div:[ courseware comment do: [:each | 
		html table:[html tableRow:[
						(html tableHeading) align:'left'; with: 'User'.
						html tableData: (each login).
		].].
		html table:[html tableRow:[
						(html tableHeading) align:'left'; with: 'Date'.
						html tableData: (each dateAndTime asTimeStamp).
		].].
		html table:[html tableRow:[
						(html tableHeading) align:'left'; with: 'Comment'.
						html tableData: (each text).
		].].
		html horizontalRule.
		]].! !

!CoursewareDetailsView methodsFor: 'rendering' stamp: 'has 7/1/2013 09:17'!
renderRatingOn: html
	| groupRating |
	html form: [
		html label: 'Rating'.
		groupRating := html radioGroup.
		groupRating radioButton
			callback:[score:= 1].
		html text: '1'.
		groupRating radioButton
			callback:[score:= 2].
		html text: '2'.
		groupRating radioButton
			callback:[score:= 3].
		html text: '3'.
		groupRating radioButton
			callback:[score:= 4].
		html text: '4'.
		groupRating radioButton
			callback:[score:= 5].
		html text: '5'.
		html space.
		html button
			callback: [self addRating: score ];
			with: 'Add'.
	].! !

!CoursewareDetailsView methodsFor: 'accessing' stamp: 'has 7/1/2013 08:33'!
score
	^score.! !

!CoursewareDetailsView methodsFor: 'accessing' stamp: 'has 7/1/2013 08:32'!
score: aScore
	score:= aScore.! !

WAComponent subclass: #CoursewareEditView
	instanceVariableNames: 'courseware authorValue tagValue courseValue courseList file fileSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!CoursewareEditView methodsFor: 'updating' stamp: 'has 6/30/2013 14:31'!
addAuthor: anAuthor
	| component authorList authorTemp |
	authorTemp := anAuthor trimBoth.
	component  := self.
	authorList := self courseware author.
	[
		((authorTemp = ''))
			ifFalse:[
					(courseware authorExists: authorTemp)
						ifFalse:[	authorList add: authorTemp.
								courseware author: authorList.
								self inform: ('The author was successfully registered.').]
						ifTrue:[self inform: ('The author already exists in this courseware.').].
					]
			ifTrue:[self inform: ('Null authors cannot be added.')]
	]
	on: Error
		do: [:sig | self inform: ('Could not add the tag due to ', sig asString)].! !

!CoursewareEditView methodsFor: 'updating' stamp: 'has 6/30/2013 12:00'!
addCourse: aCourse
	| component courseList |
	component  := self.
	courseList := self courseware course.
	[
		(courseware courseExists: aCourse)
			ifFalse:[	courseList add: aCourse.
					courseware course: courseList.
					self inform: ('The course was successfully registered.').]
			ifTrue:[self inform: ('The course already exists in this courseware.').].
	]
	on: Error
		do: [:sig | self inform: ('Could not add the course due to ', sig asString)].! !

!CoursewareEditView methodsFor: 'updating' stamp: 'has 7/1/2013 23:13'!
addTag: aTag
	| component newTag tagList tagManager tagTemp |
	tagTemp := aTag trimBoth.
	component  := self.
	tagList := self courseware tag.
	(tagList isMemberOf: OrderedCollection)
		ifFalse:[tagList:= OrderedCollection new.].
	tagManager := TagManager new.
	newTag:= Tag new.
	[
		((tagTemp = ''))
			ifFalse:[
						(Tags labelExists: tagTemp)
							ifFalse:[tagManager includeTag: tagTemp].
						(courseware tagExists: tagTemp)
							ifFalse:[	newTag label: tagTemp.
									tagList add: newTag.
									courseware tag: tagList.
									self inform: ('The tag was successfully registered.').]
							ifTrue:[self inform: ('The tag already exists in this courseware.').].
					]
			ifTrue:[self inform: ('Null tags cannot be added.')]
	]
	on: Error
		do: [:sig | self inform: ('Could not add the tag due to ', sig asString)].! !

!CoursewareEditView methodsFor: 'accessing' stamp: 'has 6/29/2013 21:27'!
courseware
	^courseware! !

!CoursewareEditView methodsFor: 'accessing' stamp: 'has 6/29/2013 21:27'!
courseware: aCourseware
	courseware:=aCourseware.! !

!CoursewareEditView methodsFor: 'initialization' stamp: 'has 6/30/2013 13:39'!
initialize
	super initialize.
	courseList:= (Course new) searchAllCourses.! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 7/2/2013 02:32'!
renderAuthorsAddOn: html
	"html div: [
		html label: 'Add Authors:'.
		html textInput
			callback:[:value | authorValue := value].
		html space.
		html button
			callback: [self addAuthor: authorValue ];
			with: 'Add'.
	]."
	(html tableHeading) align:'left'; with: 'Add Authors:'.
	html tableData: [html textInput
						callback:[:value | authorValue := value].
					html space.
					html button
						callback: [self addAuthor: authorValue ];
						with: 'Add'.].! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 7/2/2013 02:15'!
renderAuthorsOn: html
	"html div: [
		html label: 'Author:'.
		html label: courseware authorString.
	]."
	(html tableHeading) align:'left'; with: 'Author:'.
		html tableData: [html label: courseware authorString.].! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 7/2/2013 02:21'!
renderButtonsOn: html
	"html div: [
		html submitButton
			callback: [self answer: courseware];
			with: 'Save'.
		html cancelButton
			callback: [self answer: nil];
			with: 'Cancel'.
	]."
	(html tableHeading) align:'left'; with: 'Submit:'.
	html tableData: [html submitButton
						callback: [self answer: courseware];
						with: 'Save'.
					html cancelButton
						callback: [self answer: nil];
						with: 'Cancel'.].! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 7/2/2013 02:52'!
renderCataloguingDataOn: html
	"html div: [
		html label: 'Cataloguing data:'.
		html textArea
			callback: [:value | courseware cataloguingData: value];
			with: courseware cataloguingData.
	]."
	(html tableHeading) align:'left'; with: 'Cataloguing data:'.
	html tableData: [html textArea
						callback: [:value | courseware cataloguingData: value];
						with: courseware cataloguingData.].! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 7/2/2013 01:47'!
renderContentOn: html
	html heading level: 1; with: 'Edit Courseware'.
	html text: 'Edit courseware information'. 
	html form:[
	html table: [
		html tableRow: [self renderTitleOn: html.].
		html tableRow: [self renderSummaryOn: html.].
		html tableRow: [self renderDescriptionOn: html.].
		html tableRow: [self renderCoursewareTypeOn: html.].
		html tableRow: [self renderOwnerOn: html.].
		html tableRow: [self renderReferenceOn: html.].
		html tableRow: [self renderTagsOn: html.].
		html tableRow: [self renderTagsAddOn: html.].
		html tableRow: [self renderCoursesOn: html.].
		html tableRow: [self renderCoursesAddOn: html.].
		html tableRow: [self renderAuthorsOn: html.].
		html tableRow: [self renderAuthorsAddOn: html.].
		html tableRow: [self renderCataloguingDataOn: html.].
		html tableRow: [self renderLicenseTypeOn: html.].
		html tableRow: [self renderEnabledOn: html.].
		html tableRow: [self renderFileOn: html.].
		html tableRow: [self renderSizeOn: html.].
		html tableRow: [self renderUploadOn: html.].
		html tableRow: [self renderButtonsOn: html.]. 
			self yourself.  
	].  ].

		"html div:[
		self
			renderTitleOn: html;
			renderSummaryOn: html;
			renderDescriptionOn: html;
			renderCoursewareTypeOn: html;
			renderOwnerOn: html;
			renderReferenceOn: html;
			renderTagsOn: html;
			renderTagsAddOn: html;
			renderCoursesOn: html;
			renderCoursesAddOn: html;
			renderAuthorsOn: html;
			renderAuthorsAddOn: html;
			renderCataloguingDataOn: html;
			renderLicenseTypeOn: html;
			renderEnabledOn: html;
			renderFileOn: html;
			renderSizeOn: html;
			renderUploadOn: html;
			renderButtonsOn: html; 
			yourself.  
			]"! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 7/2/2013 02:48'!
renderCoursesAddOn: html
	"html div: [
		html label: 'Add Course:'.
		(html select) 
            	list: courseList;
			selected: courseValue;
			labels:[:ea | ea description];
			callback:[:value | courseValue := value].
		html space.
		html button
			callback: [self addCourse: courseValue ];
			with: 'Add'.
	]."
	(html tableHeading) align:'left'; with: 'Add Course:'.
	html tableData: [(html select) 
           					list: courseList;
						selected: courseValue;
						labels:[:ea | ea description];
						callback:[:value | courseValue := value].
					html space.
					html button
						callback: [self addCourse: courseValue ];
						with: 'Add'.].! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 7/2/2013 02:01'!
renderCoursesOn: html
	"html div: [
		html label: 'Courses:'.
		html label: courseware courseString.
	]."
	(html tableHeading) align:'left'; with: 'Courses:'.
		html tableData: [html label: courseware courseString.].! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 7/2/2013 01:54'!
renderCoursewareTypeOn: html
	"html div: [
		html label: 'CoursewareType:'.
		html select 
            	list: CoursewareType coursewareTypeList; 
            	on: #coursewareType of: self courseware;
			callback: [:value | courseware coursewareType: value].
	]."
	(html tableHeading) align:'left'; with: 'CoursewareType:'.
		html tableData: [  html select 
            					list: CoursewareType coursewareTypeList; 
            					on: #coursewareType of: self courseware;
							callback: [:value | courseware coursewareType: value].].! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 7/2/2013 01:51'!
renderDescriptionOn: html
	"html div: [
		html label: 'Description:'.
		html textArea
			callback: [:value | courseware description: value];
			with: courseware description.
	]."
	(html tableHeading) align:'left'; with: 'Description:'.
		html tableData: [  html textArea 
			callback: [:value | courseware description: value];
			with: courseware description.].! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 7/2/2013 02:14'!
renderEnabledOn: html
	| group |
	"html div: [
		html label: 'Enabled:'.
		group := html radioGroup.
		group radioButton
			selected: self courseware isEnabled;
			callback:[self courseware isEnabled:true.].
		html text: 'True'.
		group radioButton
			selected: self courseware isEnabled not;
			callback:[self courseware isEnabled:false.].
		html text: 'False'.
	]."
	(html tableHeading) align:'left'; with: 'Enabled:'.
		html tableData: [group := html radioGroup.
						group radioButton
							selected: self courseware isEnabled;
							callback:[self courseware isEnabled:true.].
						html text: 'True'.
						group radioButton
							selected: self courseware isEnabled not;
							callback:[self courseware isEnabled:false.].
						html text: 'False'.].! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 7/2/2013 02:54'!
renderFileOn: html
	"html div: [
		html label: 'File:'.
		html label: courseware file.
	]."
	(html tableHeading) align:'left'; with: 'File name:'.
	html tableData: [html label: courseware file.].! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 7/2/2013 02:53'!
renderLicenseTypeOn: html
	"html div: [
		html label: 'License:'.
		html select 
            	list: LicenseType licenseTypeList; 
            	on: #license of: self courseware;
			callback: [:value | courseware license: value].
	]."
	(html tableHeading) align:'left'; with: 'License:'.
	html tableData: [html select 
			            	list: LicenseType licenseTypeList; 
 				        	on: #license of: self courseware;
						callback: [:value | courseware license: value].].! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 7/2/2013 01:55'!
renderOwnerOn: html
	"html div: [
		html label: 'Owner:'.
		html label: courseware owner username.
	]."
	(html tableHeading) align:'left'; with: 'Owner:'.
		html tableData: [  html label: courseware owner username..].! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 7/2/2013 01:58'!
renderReferenceOn: html
	"html div: [
		html label: 'Reference:'.
		html textArea
			callback: [:value | courseware reference: value];
			with: courseware reference.
	]."
	(html tableHeading) align:'left'; with: 'Reference:'.
		html tableData: [  html textArea
							callback: [:value | courseware reference: value];
							with: courseware reference.].! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 7/2/2013 02:18'!
renderSizeOn: html
	"html div: [
		html label: 'File size:'.
		html label: (courseware size) asString, ' bytes'.
	]."
	(html tableHeading) align:'left'; with: 'File size:'.
	html tableData: [html label: (courseware size) asString, ' bytes'.].! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 7/2/2013 02:17'!
renderSummaryOn: html
	"html div: [
		html label: 'Summary:'.
		html textArea
			callback: [:value | courseware summary: value];
			with: courseware summary.
	]."
	(html tableHeading) align:'left'; with: 'Summary:'.
	html tableData: [  html textArea 
		callback: [:value | courseware summary: value];
		with: courseware summary.].
	"]."! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 7/2/2013 02:41'!
renderTagsAddOn: html
	"html div: [
		html label: 'Add Tags:'.
		html textInput
			callback:[:value | tagValue := value].
		html space.
		html button
			callback: [self addTag: tagValue ];
			with: 'Add'.
	]."
	(html tableHeading) align:'left'; with: 'Add Tags:'.
	html tableData: [html textInput
						callback:[:value | tagValue := value].
					html space.
					html button
						callback: [self addTag: tagValue ];
						with: 'Add'.].! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 7/2/2013 01:57'!
renderTagsOn: html
	"html div: [
		html label: 'Tags:'.
		html label: courseware tagString.
	]."
	(html tableHeading) align:'left'; with: 'Tags:'.
		html tableData: [html label: courseware tagString.].! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 6/30/2013 08:17'!
renderTagsSearchOn: html for: type
	html div: [
		html label: 'Add Tags:'.
		html searchInput
			id: ('inputfield');
			onSearch: (Tags searchTagByLabel: type);
			onKeyUp: (Tags searchTagByLabel: type).
	].! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 7/2/2013 01:50'!
renderTitleOn: html
	"html div: ["
		(html tableHeading) align:'left'; with: 'Title:'.
		html tableData: [  html textArea 
			callback: [:value | courseware title: value];
			with: courseware title.].
	"]."! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 7/2/2013 02:20'!
renderUploadOn: html
	"html div: [
		html anchor
		callback: [self uploadFile];
		with: 'Upload courseware'.
	]."
	(html tableHeading) align:'left'; with: 'File:'.
	html tableData: [html anchor
						callback: [self uploadFile];
						with: 'Upload courseware'.].! !

!CoursewareEditView methodsFor: 'updating' stamp: 'has 6/30/2013 19:12'!
uploadFile
	| component |
	component  := UploadCourseware new.
	file := self call: component.
	
	[(file fileName ~= '')
		ifTrue: [
				courseware file: file fileName.
				courseware size: file size.
				courseware modificationDateTime: DateAndTime now.
				(CoursewareManager new) updateCourseware: courseware.
				self inform: ('Your file was successfully uploaded.').
				]
	]  
	on: Error
	do: [:sig | self inform: ('Could not add the file due to ', sig asString)].! !

WAComponent subclass: #CoursewareListView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!CoursewareListView methodsFor: 'rendering' stamp: 'has 7/1/2013 11:43'!
addCourseware
	| component courseware |
	component  := CoursewareAddView new.
	courseware := self call: component.
	
	(courseware notNil)
		ifTrue: [
				[	
					(CoursewareManager new) includeCourseware: courseware.
					self inform: ('Courseware successfully created.').
				]  
				on: Error
				do: [:sig | 
					OCMSDB session abort.
					self inform: ('Could not create courseware due to ', sig asString)].
		].! !

!CoursewareListView methodsFor: 'rendering' stamp: 'has 6/29/2013 11:14'!
back
	self answer.! !

!CoursewareListView methodsFor: 'rendering' stamp: 'has 6/29/2013 15:07'!
coursewareDetails: aCourseware on: html
	
	html heading level: 1; 
		with: aCourseware title.
	html space.
	html anchor
		callback: [self back];
		with: 'Coursewares'.! !

!CoursewareListView methodsFor: 'rendering' stamp: 'has 7/1/2013 11:44'!
editCourseware: aCourseware
	| component courseware |
	component  := CoursewareEditView new.
	component courseware: aCourseware.
	courseware := self call: component.
	
	(courseware isMemberOf: Courseware)
		ifTrue: [
				[	courseware modificationDateTime: DateAndTime now.
					(CoursewareManager new) updateCourseware: courseware.
					self inform: ('Courseware successfully updated.').
				]  
				on: Error
				do: [:sig | 
					OCMSDB session abort.
					self inform: ('Could not update due to ', sig asString)].
		].! !

!CoursewareListView methodsFor: 'rendering' stamp: 'has 7/1/2013 11:48'!
renderContentOn: html
	"I render the list of coursewares"

	html heading level: 1;
				with: 'Coursewares'.
	html break.
	html anchor
		callback: [self back];
		with: 'Home'.
	html break.
	html anchor
		callback:[self addCourseware];
		with: 'Add a new courseware'.
	html break.
	html unorderedList: [self renderItemsOn: html].! !

!CoursewareListView methodsFor: 'rendering' stamp: 'has 6/29/2013 17:05'!
renderItem: aCourseware on: html
	
	html listItem
		with: [html text: aCourseware title.
				html space.
				html anchor
					callback:[self showCoursewareDetails: aCourseware];
					with: 'details'.
				html space.
				html anchor
					callback:[self editCourseware: aCourseware];
					with: 'edit'.
				].! !

!CoursewareListView methodsFor: 'rendering' stamp: 'has 6/29/2013 13:25'!
renderItemsOn: html
	| coursewareList batchedList coursewareTitleList selection |
	coursewareList:= Coursewares getAll.
	coursewareList do:[:each | self renderItem: each on: html].
	"coursewareTitleList :=  OrderedCollection new.
	coursewareList do:[:each | coursewareTitleList add: each title]."
	"batchedList := WABatchedList new.
	batchedList items: coursewareTitleList asArray.
	batchedList batchSize: 10."
	"batchedList renderContentOn: html."
	"selection:= WABatchSelection items: coursewareList link: #id text: #title.
	selection batchSize: 20.
	selection onAnswer: [:item | self renderItem: item on:html]. 
	html render: selection."! !

!CoursewareListView methodsFor: 'rendering' stamp: 'has 6/29/2013 16:12'!
showCoursewareDetails
	self call: (CoursewareDetailsView new).! !

!CoursewareListView methodsFor: 'rendering' stamp: 'oda 7/1/2013 15:37'!
showCoursewareDetails: aCourseware
	self call: (CoursewareDetailsView on: aCourseware).! !

WAComponent subclass: #GroupAddView
	instanceVariableNames: 'group'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!GroupAddView methodsFor: 'initialize-release' stamp: 'oda 7/1/2013 18:43'!
initialize
	super initialize.
	group := Group new.
! !

!GroupAddView methodsFor: 'rendering' stamp: 'oda 6/30/2013 21:26'!
renderButtonsOn: html
	html div: [
		html submitButton
			callback: [self answer: group];
			with: 'Confirm'.
		html cancelButton
			callback: [self answer: nil];
			with: 'Cancel'.
	].! !

!GroupAddView methodsFor: 'rendering' stamp: 'oda 6/30/2013 21:26'!
renderContentOn: html
	html heading level: 1; with: 'New group'.
	html text: 'Type the group''s Info'. 
	
	html form: [
		self
			renderDescriptionOn: html;
			renderPasswordOn: html;  
			renderButtonsOn: html;  
			yourself.  
	].  ! !

!GroupAddView methodsFor: 'rendering' stamp: 'oda 6/30/2013 21:36'!
renderDescriptionOn: html
	html div: [
		html label: 'Name:'.
		html textInput
			callback: [:value | group description: value].
	]! !

!GroupAddView methodsFor: 'rendering' stamp: 'oda 7/1/2013 04:11'!
renderPasswordOn: html
	html div: [
		html label: 'Password:'.
		html passwordInput
			callback: [:value |
				group password: value hash.
				group isOpen: value isEmpty.
			].
		html text: '(Empty creates an open group)'.
	].! !

WAComponent subclass: #GroupDetailsView
	instanceVariableNames: 'group coursewareCollection userCollection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!GroupDetailsView class methodsFor: 'instance creation' stamp: 'oda 7/1/2013 15:05'!
on: aGroup
	^self basicNew
		initialize: aGroup;
		yourself.
		  ! !

!GroupDetailsView methodsFor: 'updating' stamp: 'has 7/1/2013 20:55'!
addCourseware
	| component courseware |
	component  := CoursewareAddView new.
	component courseValue: group course.
	courseware := self call: component.
	
	(courseware notNil)
		ifTrue: [
				[	courseware course add: group course.
					(CoursewareManager new) includeCourseware: courseware.
					self inform: ('Courseware successfully created.').
				]  
				on: Error
				do: [:sig | 
					OCMSDB session abort.
					self inform: ('Could not create courseware due to ', sig asString)].
		].! !

!GroupDetailsView methodsFor: 'updating' stamp: 'has 7/2/2013 09:01'!
deleteCourseware: aCourseware
	| component courseware coursewareManager |
	component := ConfirmView on: 'Are you sure you want to delete this courseware?'.
	courseware := self call: component.

	(courseware)
		ifTrue: [	
				coursewareManager := CoursewareManager new.
				[
					coursewareManager removeCourseware: aCourseware.
					self inform: ('Courseware successfully deleted.').
				]  
				on: Error
				do: [:sig |
					OCMSDB session abort.
					self inform: ('Failed it due to ', sig asString)
				].
		].
! !

!GroupDetailsView methodsFor: 'updating' stamp: 'has 7/1/2013 20:05'!
editCourseware: aCourseware
	| component courseware |
	component  := CoursewareEditView new.
	component courseware: aCourseware.
	courseware := self call: component.
	
	(courseware isMemberOf: Courseware)
		ifTrue: [
				[	courseware modificationDateTime: DateAndTime now.
					(CoursewareManager new) updateCourseware: courseware.
					self inform: ('Courseware successfully updated.').
				]  
				on: Error
				do: [:sig | 
					OCMSDB session abort.
					self inform: ('Could not update due to ', sig asString)].
		].! !

!GroupDetailsView methodsFor: 'updating' stamp: 'has 7/2/2013 12:37'!
fillCoursewareCollection
	^(CoursewareManager new) searchCoursewareByGroup: group.! !

!GroupDetailsView methodsFor: 'initialize-release' stamp: 'has 7/2/2013 12:51'!
initialize: aGroup
	self initialize.
	group := aGroup.    
	coursewareCollection := OrderedCollection new.
	userCollection := OrderedCollection new.! !

!GroupDetailsView methodsFor: 'rendering' stamp: 'oda 7/1/2013 22:42'!
renderContentOn: html
	html heading
		level: 1;  
		with: 'Group ', group description.
	html anchor
		callback:[self addCourseware];
		with: 'New courseware'.
	self renderCoursewaresOn: html.
	self renderMembersOn: html.  ! !

!GroupDetailsView methodsFor: 'rendering' stamp: 'has 7/2/2013 08:57'!
renderCoursewareAnchorOf: aCourseware on: html.
	html tableRow: [
		html tableData:[
			html text: aCourseware title.
		].
		html tableData:[
			html anchor
				callback:[self showCoursewareDetails: aCourseware];
					with: 'Details'.
		].
		(aCourseware owner = self session user) ifTrue: [
			html tableData: [
				html anchor
					callback:[self editCourseware: aCourseware];
					with: 'Edit'.
			].
			html tableData: [
				html anchor
					callback: [self deleteCourseware: aCourseware];
					with: 'Delete'.
			].
		]
	]! !

!GroupDetailsView methodsFor: 'rendering' stamp: 'has 7/2/2013 12:39'!
renderCoursewaresOn: html
	html heading
		level: 2;  
		with: 'Coursewares of ',group description.
		
	(coursewareCollection isEmpty)
		ifTrue:[coursewareCollection := self fillCoursewareCollection].
	
	coursewareCollection isEmpty ifTrue: [
		html text: '(none)'
	] ifFalse: [
		html anchor
			callback:[self sortCoursewaresByTitle:coursewareCollection.];
			with:'Sort by Title'.
		html break.
		html break.
		html table: [
			#(Title) do: [:each | html tableData: [html strong: each.]].
			coursewareCollection do: [:each | self renderCoursewareAnchorOf: each on: html.]
		].
	].! !

!GroupDetailsView methodsFor: 'rendering' stamp: 'oda 7/1/2013 15:19'!
renderMember: anUser on: html
	html tableRow: [
		html tableData: [
			html text: anUser username.
		].
		html tableData: [
			html text: anUser email.
		].
		html tableData: [
			html text: (anUser roleAtGroup: group).
		].
	].! !

!GroupDetailsView methodsFor: 'rendering' stamp: 'has 7/2/2013 13:02'!
renderMembersOn: html
	html heading
		level: 2;  
		with: 'Members'.
		
	(userCollection isEmpty)
		ifTrue:[userCollection := group user].
	html anchor
		callback:[self sortUsersByName:userCollection.];
		with:'Sort by Name'.
	html space.
	html anchor
		callback:[self sortUsersByEmail:userCollection.];
		with:'Sort by Email'.
	html space.
	html anchor
		callback:[self sortUsersByRole:userCollection.];
		with:'Sort by Role'.
	html space.
	html break.
	html break.
	html table: [
		#(Name Email Role) do: [:each | html tableData: [html strong: each.]].
		userCollection do: [:each | self renderMember: each on: html].
	].! !

!GroupDetailsView methodsFor: 'rendering' stamp: 'has 7/1/2013 20:03'!
showCoursewareDetails: aCourseware
	self call: (CoursewareDetailsView on: aCourseware).! !

!GroupDetailsView methodsFor: 'updating' stamp: 'has 7/2/2013 12:25'!
sortCoursewaresByTitle: aCoursewareCollection
		
	| component |
	component := self.
	[
		coursewareCollection:= (CoursewareManager new) sortByTitle: aCoursewareCollection.
	]  
	on: Error
	do: [:sig |
		self inform: ('Failed it due to ', sig asString)
	].! !

!GroupDetailsView methodsFor: 'updating' stamp: 'has 7/2/2013 12:54'!
sortUsersByEmail: anUserCollection
		
	| component |
	component := self.
	[
		userCollection:= (UserManager new) sortByEmail: anUserCollection.
	]  
	on: Error
	do: [:sig |
		self inform: ('Failed it due to ', sig asString)
	].! !

!GroupDetailsView methodsFor: 'updating' stamp: 'has 7/2/2013 12:53'!
sortUsersByName: anUserCollection
		
	| component |
	component := self.
	[
		userCollection:= (UserManager new) sortByName: anUserCollection.
	]  
	on: Error
	do: [:sig |
		self inform: ('Failed it due to ', sig asString)
	].! !

!GroupDetailsView methodsFor: 'updating' stamp: 'has 7/2/2013 13:01'!
sortUsersByRole: anUserCollection
		
	| component |
	component := self.
	[
		userCollection:= (UserManager new) sortByRole: anUserCollection ofGroup: group.
	]  
	on: Error
	do: [:sig |
		self inform: ('Failed it due to ', sig asString)
	].! !

WAComponent subclass: #GroupEditView
	instanceVariableNames: 'group'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!GroupEditView class methodsFor: 'instance creation' stamp: 'oda 7/1/2013 02:27'!
on: aGroup
	^self basicNew
		initialize: aGroup;
		yourself.  ! !

!GroupEditView methodsFor: 'initialize-release' stamp: 'oda 7/1/2013 02:27'!
initialize: aGroup
	self initialize.
	group := aGroup.    ! !

!GroupEditView methodsFor: 'rendering' stamp: 'oda 7/1/2013 02:30'!
renderButtonsOn: html
	html div: [
		html submitButton
			callback: [self answer: group];
			with: 'Confirm'.
		html cancelButton
			callback: [self answer: nil];
			with: 'Cancel'.
	].! !

!GroupEditView methodsFor: 'rendering' stamp: 'oda 7/1/2013 02:51'!
renderContentOn: html
	html heading level: 1; with: 'Edit group ', group description.
	html paragraph: 'Type the course''s Info'. 
	
	html form: [
		self
			renderDescriptionOn: html;
			renderPasswordOn: html;
			renderButtonsOn: html;  
			yourself.  
	].  ! !

!GroupEditView methodsFor: 'rendering' stamp: 'oda 7/1/2013 02:29'!
renderDescriptionOn: html
	html div: [
		html label: 'Name:'.
		html text: group description.
	]! !

!GroupEditView methodsFor: 'rendering' stamp: 'oda 7/1/2013 04:13'!
renderPasswordOn: html
	html div: [
		html label: 'Password:'.
		html passwordInput
			callback: [:value |
				group password: value hash.
				group isOpen: value isEmpty.
			].
		html text: '(Empty creates an open group)'.
	].! !

WAComponent subclass: #GroupJoinView
	instanceVariableNames: 'group password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!GroupJoinView class methodsFor: 'instance creation' stamp: 'oda 7/1/2013 02:57'!
on: aGroup
	^self basicNew
		initialize: aGroup;
		yourself.  ! !

!GroupJoinView methodsFor: 'initialize-release' stamp: 'oda 7/1/2013 02:57'!
initialize: aGroup
	self initialize.  
	group := aGroup.  ! !

!GroupJoinView methodsFor: 'rendering' stamp: 'oda 7/1/2013 03:20'!
joinGroup
	(group isOpen)
		ifTrue: [self answer: (self session user joinGroup: group)]
		ifFalse: [self answer: (self session user joinGroup: group withPassword: password)].
! !

!GroupJoinView methodsFor: 'rendering' stamp: 'oda 7/1/2013 03:25'!
renderButtonsOn: html
	html div: [ 
		html submitButton
			callback: [self joinGroup];
			with: 'Join'.
		html cancelButton
			callback: [self answer: nil];
			with: 'Cancel'.
	].! !

!GroupJoinView methodsFor: 'rendering' stamp: 'oda 7/1/2013 04:09'!
renderContentOn: html
	html paragraph: 'Are you sure you want to join this group?.'.  
	html form: [
		(group isOpen)
			ifFalse: [
				html paragraph: 'This group has a password.'.  
				self renderPasswordOn: html.  
			]. 
		self renderButtonsOn: html.
	]  ! !

!GroupJoinView methodsFor: 'rendering' stamp: 'oda 7/1/2013 03:06'!
renderPasswordOn: html
	html div: [ 
		html label: 'Password:'.
		html passwordInput
			callback: [:value | password := value];
			yourself.
	].! !

WAComponent subclass: #GroupListView
	instanceVariableNames: 'course'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!GroupListView class methodsFor: 'instance creation' stamp: 'oda 6/30/2013 21:14'!
on: aCourse
	^self basicNew
		initialize: aCourse;
		yourself.! !

!GroupListView methodsFor: 'updating' stamp: 'oda 7/1/2013 16:51'!
addGroup
	| component answer |
	component := GroupAddView new.
	answer := self call: component.

	(answer notNil)
		ifTrue: [	
				[
					(GroupManager new) includeGroup: answer atCourse: course byUser: (self session user).
					self inform: ('Group successfully added. Wait for an admin unlock it.').
				]  
				on: Error
				do: [:sig |
					self inform: ('Failed due to ', sig asString)
				].
		].! !

!GroupListView methodsFor: 'updating' stamp: 'oda 7/1/2013 18:39'!
blockGroup: aGroup
	| component answer groupManager |
	component := ConfirmView on: 'Are you sure you want to block this group?'.
	answer := self call: component.

	(answer)
		ifTrue: [	
				groupManager := GroupManager new.
				[
					groupManager blockGroup: aGroup.
					self inform: ('Group successfully blocked.').
				]
				on: Error
				do: [:sig |
					OCMSDB session abort.
					self inform: ('Failed due to ', sig asString)
				].
		].
! !

!GroupListView methodsFor: 'updating' stamp: 'oda 7/1/2013 16:51'!
deleteGroup: aGroup
	| component answer groupManager |
	component := ConfirmView on: 'Are you sure you want to delete this group?'.
	answer := self call: component.

	(answer)
		ifTrue: [	
				groupManager := GroupManager new.
				[
					groupManager removeGroup: aGroup.
					self inform: ('Group successfully deleted.').
				]  
				on: Error
				do: [:sig |
					OCMSDB session abort.
					self inform: ('Failed due to ', sig asString)
				].
		].
! !

!GroupListView methodsFor: 'updating' stamp: 'oda 7/1/2013 16:51'!
editGroup: aGroup
	| component answer |
	component := GroupEditView on: aGroup.
	answer := self call: component.

	(answer notNil)
		ifTrue: [	
				[
					(GroupManager new) updateGroup: answer.
					self inform: ('Group successfully updated.').
				]  
				on: Error
				do: [:sig |
					OCMSDB session abort.
					self inform: ('Failed due to ', sig asString)
				].
		].
! !

!GroupListView methodsFor: 'initialize-release' stamp: 'oda 7/1/2013 01:49'!
initialize: aCourse
	self initialize.
	course := aCourse.  ! !

!GroupListView methodsFor: 'updating' stamp: 'oda 7/1/2013 16:51'!
joinGroup: aGroup
	| component answer |
	component := GroupJoinView on: aGroup.
	answer := self call: component.

	(answer notNil)
		ifTrue: [	
			(answer) "Joined?"
				ifTrue: [
					[
						(GroupManager new) updateGroup: aGroup.
						(UserManager new) updateUser: (self session user).  
						self inform: ('Joined.').
					]  
					on: Error
					do: [:sig |
						OCMSDB session abort.
						self inform: ('Failed due to ', sig asString)
					].
				] ifFalse: [
					self inform: ('Wrong password.')
				]  
		].
! !

!GroupListView methodsFor: 'rendering' stamp: 'oda 7/1/2013 00:00'!
renderAddAnchorOn: html
	html anchor
		callback: [self addGroup];
		with: 'New group'.
	html break.
! !

!GroupListView methodsFor: 'rendering' stamp: 'oda 7/1/2013 18:41'!
renderAdminItem: aGroup on: html
	| user |
	user := self session user.
	html tableRow: [
		html tableData: [
			html anchor
				callback: [self call: (GroupDetailsView on: aGroup)];
				with: aGroup description;
				yourself.
		].
		(aGroup isEnabled) ifTrue: [
			html tableData: [
				html anchor
					callback: [self blockGroup: aGroup];  
					with: 'Block'.
			].
		] ifFalse: [  
			html tableData: [
				html anchor
					callback: [self unblockGroup: aGroup];  
					with: 'Unblock'.
			].
		].
	].! !

!GroupListView methodsFor: 'rendering' stamp: 'oda 6/30/2013 23:33'!
renderContentOn: html
	html heading
		level: 1;
		with: 'Groups of ', course description.
	html paragraph: [
		self renderAddAnchorOn: html.
	].
	self renderItemsOn: html.! !

!GroupListView methodsFor: 'rendering' stamp: 'oda 7/1/2013 18:22'!
renderItem: aGroup on: html
	self session user isAdmin ifTrue: [
		self renderAdminItem: aGroup on: html.
	] ifFalse: [
		self renderStandardItem: aGroup on: html.
	]! !

!GroupListView methodsFor: 'rendering' stamp: 'oda 7/1/2013 18:30'!
renderItemsOn: html
	| groupList |
	groupList := course group.

	self session user isAdmin ifFalse: [
		groupList := groupList select: [:each | each isEnabled]
	].

	html table: [
		groupList do: [:each | self renderItem: each on: html].
	]! !

!GroupListView methodsFor: 'rendering' stamp: 'oda 7/1/2013 18:15'!
renderStandardItem: aGroup on: html
	| user |
	user := self session user.
	html tableRow: [
		(user group includes: aGroup) ifFalse: [
			html tableData: [html text: aGroup description.].
			html tableData: [
				html anchor
					callback: [self joinGroup: aGroup];
					with: 'Join';
					yourself.
			].
		] ifTrue: [  
			html tableData: [
				html anchor
					callback: [self call: (GroupDetailsView on: aGroup)];
					with: aGroup description;
					yourself.
			].
			html tableData: [html text: (self session user roleAtGroup: aGroup).].

			(aGroup owner = user) ifTrue: [
				html tableData: [
					html anchor
						callback: [self editGroup: aGroup ];
						with: 'Edit'.
				].
				html tableData: [
					html anchor
						callback: [self deleteGroup: aGroup ];  
						with: 'Delete'.
				].
			].
		].
	].! !

!GroupListView methodsFor: 'updating' stamp: 'oda 7/1/2013 18:40'!
unblockGroup: aGroup
	| component answer groupManager |
	component := ConfirmView on: 'Are you sure you want to unblock this group?'.
	answer := self call: component.

	(answer)
		ifTrue: [	
				groupManager := GroupManager new.
				[
					groupManager unblockGroup: aGroup.
					self inform: ('Group successfully unblocked.').
				]
				on: Error
				do: [:sig |
					OCMSDB session abort.
					self inform: ('Failed due to ', sig asString)
				].
		].
! !

WAComponent subclass: #HomeView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!HomeView methodsFor: 'rendering' stamp: 'oda 7/1/2013 22:17'!
renderContentOn: html
	html heading
		level2;
		with: 'Welcome'.
	html paragraph: 'Open Courseware Management System is a system to store and share open courseware to academic institutions.'.
	html paragraph: 'It was made by: Higor Amario (hamario@ime.usp.br), Monna Cleide (monnacs@gmail.com) and Ricardo Oda (odaric@ime.usp.br).'.
! !

WAComponent subclass: #LoginComponent
	instanceVariableNames: 'login password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!LoginComponent methodsFor: 'updating' stamp: 'oda 6/30/2013 21:45'!
authenticateUser
	| user |
	user := (UserManager new)
		authenticateUserWithLogin: login
		withPassword: password.
		self session user: user.
	user notNil
		ifTrue: [
			login := nil.
			password := nil.
		]! !

!LoginComponent methodsFor: 'updating' stamp: 'oda 7/1/2013 16:52'!
registerUser
	| component answer |
	login := nil. "clear warning"
	
	component  := UserRegistrationView new.
	answer := self call: component.
	
	(answer isMemberOf: User)
		ifTrue: [
				[
					(UserManager new) includeUser: answer.
					self inform: ('User successfully registered. Wait for an admin unlock it.').
				]  
				on: Error
				do: [:sig | self inform: ('Failed due to ', sig asString)].
		].! !

!LoginComponent methodsFor: 'rendering' stamp: 'has 7/2/2013 10:37'!
renderContentOn: html
	self session user isNil ifTrue: [
		self renderFormOn: html.  
	] ifFalse: [
		html heading: 'Welcome ', self session user login.
		html break.
		html text: 'You have ',(((OCMSNotificationManager new) unreadNotificationOfUser: self session user)size) asString,' new notifications.'
	]  
! !

!LoginComponent methodsFor: 'rendering' stamp: 'oda 6/30/2013 17:07'!
renderFormOn: html
	html form
		class: 'loginForm';
		with: [ 
			self 
				renderWarningOn: html;
				renderLoginOn: html;
				renderPasswordOn: html;
				renderSubmitOn: html;
				yourself.
		].
	self renderRegisterAnchorOn: html.  ! !

!LoginComponent methodsFor: 'rendering' stamp: 'oda 6/30/2013 02:07'!
renderLoginOn: html
	html div: [ 
		html label: 'User:'.
		html textInput
			callback: [:value | login := value];
			yourself.
	].! !

!LoginComponent methodsFor: 'rendering' stamp: 'oda 6/29/2013 20:33'!
renderPasswordOn: html
	html div: [ 
		html label: 'Password:'.
		html passwordInput
			callback: [:value | password := value];
			yourself.
	].! !

!LoginComponent methodsFor: 'rendering' stamp: 'oda 6/30/2013 17:06'!
renderRegisterAnchorOn: html
	html anchor
		callback: [self registerUser];
		with: 'Register'.
	html break.! !

!LoginComponent methodsFor: 'rendering' stamp: 'oda 6/29/2013 23:17'!
renderSubmitOn: html
	html div: [ 
		html submitButton
			callback: [self authenticateUser];
			with: 'Login'.
	].! !

!LoginComponent methodsFor: 'rendering' stamp: 'oda 6/30/2013 02:05'!
renderUserOn: html
	html div: [ 
		html label: 'User:'.
		html textInput
			callback: [:value | login := value];
			yourself.
	].! !

!LoginComponent methodsFor: 'rendering' stamp: 'oda 6/29/2013 20:24'!
renderWarningOn: html
	html div: [
		html
			span: self warning;
			yourself.
	].! !

!LoginComponent methodsFor: 'updating' stamp: 'oda 6/29/2013 20:24'!
warning
	self session user notNil
		ifTrue: [	^'Logged in as ' , self session user login.].

	(login isNil or: [login isEmpty])
		ifTrue: [	^'Please enter User ID and Password'.].

	^'Login failed!!'.! !

WAComponent subclass: #NotificationDetailsView
	instanceVariableNames: 'notification'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!NotificationDetailsView class methodsFor: 'instance creation' stamp: 'oda 7/1/2013 20:17'!
on: aNotication
	^self basicNew
		initialize: aNotication;
		yourself.  ! !

!NotificationDetailsView methodsFor: 'initialize-release' stamp: 'oda 7/1/2013 20:16'!
initialize: aNotification
	self initialize.
	notification := aNotification.    ! !

!NotificationDetailsView methodsFor: 'rendering' stamp: 'oda 7/1/2013 20:39'!
renderContentOn: html
	html anchor
		callback: [self answer];
		with: 'back'.

	html heading
		level: 1;
		with: notification title.
		html paragraph: (notification dateAndTime asTimeStamp).

	html paragraph: [
		html strong: 'From: '.
		notification isSystemNotification ifTrue: [
			html emphasis: 'System'.
		] ifFalse: [
			html text: notification sender.
		]. 
		html break. 
		html strong: 'To: '.
		notification receiver do: [:each |
			html space.
			html text: each login, ';'
		].
	].
	
	html paragraph: notification body.  
! !

WAComponent subclass: #NotificationListView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!NotificationListView methodsFor: 'rendering' stamp: 'oda 7/1/2013 20:42'!
readNotification: aNotification
	aNotification readWithUser: (self session user).
	self call: (NotificationDetailsView on: aNotification).! !

!NotificationListView methodsFor: 'rendering' stamp: 'oda 7/1/2013 20:01'!
renderContentOn: html
	html heading
		level: 1;
		with: 'Notifications'.
	self renderItemsOn: html.  ! !

!NotificationListView methodsFor: 'rendering' stamp: 'oda 7/1/2013 20:43'!
renderItem: aNotification on: html
	html tableRow: [
		html tableData: [
			html anchor
				callback: [self readNotification: aNotification];
				with: aNotification title.
		].
		html tableData: [
			(aNotification isReadByUser: (self session user)) ifTrue: [
				html text: '-'
			] ifFalse: [
				html text: 'new'
			]    
		].
		html tableData: [
			html text: aNotification dateAndTime asTimeStamp.
		].
	]! !

!NotificationListView methodsFor: 'rendering' stamp: 'oda 7/1/2013 20:45'!
renderItemsOn: html
	| notificationList |
	notificationList := OCMSNotifications getAll select: [:each | each receiver includes: (self session user)].
	notificationList := notificationList asSortedCollection reverse.
	html table: [
		#(Title Status DateAndTime) do: [:each | html tableData: [html strong: each.]].
		notificationList do: [:each | self renderItem: each on: html].
	]! !

WAComponent subclass: #OCMSHome
	instanceVariableNames: 'mainArea'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!OCMSHome class methodsFor: 'root' stamp: 'monnacs 6/26/2013 21:06'!
canBeRoot

 
^true! !

!OCMSHome class methodsFor: 'initialize-release' stamp: 'oda 6/29/2013 20:10'!
initialize
"
	OCMSHome initialize
"
	super initialize.
	(self registerAsApplication: 'ocms')
		preferenceAt: #sessionClass put: OCMSSession;
		yourself.! !

!OCMSHome methodsFor: 'initialize-release' stamp: 'oda 6/30/2013 21:47'!
initialize
	| user |
	super initialize.
	
	user := self session user.
	mainArea := LoginComponent new.
	! !

!OCMSHome methodsFor: 'rendering-sidebar' stamp: 'oda 7/1/2013 17:45'!
renderAdminMenuOn: html
	(self session user notNil and: [self session user isAdmin]) ifTrue: [
		html heading
			level: 3;
			with: 'Admin Menu'.
		self renderUserAnchorOn: html.
	]
! !

!OCMSHome methodsFor: 'rendering' stamp: 'oda 6/30/2013 02:16'!
renderContentOn: html
	"I render everything by calling html"
	html div
		id: 'allcontent';
		with: [
			self
				renderHeaderOn: html;
				renderMainOn: html;
				renderSidebarOn: html;  
				renderFooterOn: html;
				yourself.
		].! !

!OCMSHome methodsFor: 'rendering-sidebar' stamp: 'oda 7/1/2013 15:45'!
renderCourseAnchorOn: html
	self session user isNil ifFalse: [
		html anchor
			callback: [mainArea := CourseListView new];
			with: 'Courses'.
		html break.
	]! !

!OCMSHome methodsFor: 'rendering-sidebar' stamp: 'oda 7/1/2013 15:48'!
renderCoursewareAnchorOf: aCourseware on: html.
	html anchor
		callback: [mainArea := (CoursewareDetailsView on: aCourseware)];
		with: aCourseware title;
		yourself.
	html break.
! !

!OCMSHome methodsFor: 'rendering' stamp: 'oda 7/1/2013 22:27'!
renderFooterOn: html
	html div
		id: 'footer';
		class: 'section';
		with: [
			html text: 'Object-oriented programming 2013.'.
		].! !

!OCMSHome methodsFor: 'rendering-sidebar' stamp: 'oda 7/1/2013 18:46'!
renderGroupAnchorOf: aGroup on: html.
	html anchor
		callback: [mainArea := (GroupDetailsView on: aGroup)];
		with: aGroup description;
		yourself.
	aGroup isEnabled ifFalse: [
		html space.
		html text: '(blocked)'.
	].   
	html break.
! !

!OCMSHome methodsFor: 'rendering' stamp: 'oda 7/1/2013 22:14'!
renderHeaderOn: html
	html div
		id: 'footer';
		class: 'section';
		with: [
			html heading
				level1;
				with: 'Open Courseware Management System'.
			html text: 'A system to store and share open courseware to academic institutions'.
		].! !

!OCMSHome methodsFor: 'rendering-sidebar' stamp: 'oda 7/1/2013 22:16'!
renderHomeAnchorOn: html
	html anchor
		callback: [mainArea := (HomeView new)];
		with: 'Home';
		yourself.
	html break.! !

!OCMSHome methodsFor: 'rendering-sidebar' stamp: 'oda 6/30/2013 17:00'!
renderLoginAnchorOn: html
	html anchor
		callback: [mainArea := LoginComponent new];
		with: 'Login'.
	html break.! !

!OCMSHome methodsFor: 'rendering-sidebar' stamp: 'oda 6/30/2013 21:47'!
renderLogoutAnchorOn: html
	html anchor
		callback: [
			self session user: nil.
			mainArea := LoginComponent new.
		];
		with: 'Logout'.
	html break.! !

!OCMSHome methodsFor: 'rendering' stamp: 'oda 6/30/2013 01:34'!
renderMainOn: html
	| user |
	user := self session user.
	html div
		id: 'main';
		class: 'section';
		with: [ html render: mainArea ].
! !

!OCMSHome methodsFor: 'rendering-sidebar' stamp: 'oda 7/1/2013 20:06'!
renderMenuOn: html
	html heading
		level: 3;
		with: 'Menu'.
	self renderHomeAnchorOn: html.
	self renderNotificationAnchorOn: html.
	self renderCourseAnchorOn: html.  ! !

!OCMSHome methodsFor: 'rendering-sidebar' stamp: 'oda 7/1/2013 21:39'!
renderMyCoursewaresOn: html
	| coursewares user |
	user := self session user.
	(user notNil )
	ifTrue: [
		coursewares := Coursewares searchByOwner: user.  
		html heading
			level: 3;
			with: 'My Coursewares'.
		coursewares isEmpty ifTrue: [html text: '(none)'].  
		coursewares do: [:each |
			self renderCoursewareAnchorOf: each on: html.
		].
	].
	

! !

!OCMSHome methodsFor: 'rendering-sidebar' stamp: 'oda 7/1/2013 21:39'!
renderMyGroupsOn: html
	| user groups |
	user := self session user.
	( user notNil )
	ifTrue: [
		groups := user group.
		html heading
			level: 3;
			with: 'My Groups'.
		groups isEmpty ifTrue: [html text: '(none)'].
		groups asSortedCollection do: [:each |
			self renderGroupAnchorOf: each on: html.
		].
	].
	

! !

!OCMSHome methodsFor: 'rendering-sidebar' stamp: 'oda 7/1/2013 20:05'!
renderNotificationAnchorOn: html
	self session user isNil ifFalse: [
		html anchor
			callback: [mainArea := NotificationListView new];
			with: 'Notifications'.
		html break.
	]! !

!OCMSHome methodsFor: 'rendering-sidebar' stamp: 'oda 7/1/2013 16:59'!
renderSidebarOn: html
	html div
		id: 'sidebar';
		class: 'section';
		with: [ 
			self renderUserOn: html.
			self renderAdminMenuOn: html.
			self renderMenuOn: html.    
			self renderMyGroupsOn: html.
			self renderMyCoursewaresOn: html.
		]! !

!OCMSHome methodsFor: 'rendering-sidebar' stamp: 'oda 7/1/2013 17:45'!
renderUserAnchorOn: html
	html anchor
		callback: [mainArea := UserListView new];
		with: 'Users'.
	html break.
! !

!OCMSHome methodsFor: 'rendering-sidebar' stamp: 'oda 7/1/2013 15:46'!
renderUserOn: html
	self session user isNil ifTrue: [
		self renderLoginAnchorOn: html.
	] ifFalse: [
		html text: 'Logged as '.
		html strong: (self session user username).
		html break.
		self renderLogoutAnchorOn: html.
	].! !

!OCMSHome methodsFor: 'updating' stamp: 'oda 6/29/2013 23:40'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	
	anHtmlRoot title: 'OCMS'.
	anHtmlRoot link
		type: 'text/css';
		beStylesheet;
		addAll;
		url: OCMSFileLibrary / 'ocms.css';
		yourself.

	"old css
	anHtmlRoot stylesheet url: 'http://seaside.st/styles/main.css'"
! !

WAComponent subclass: #UploadCourseware
	instanceVariableNames: 'file'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!UploadCourseware methodsFor: 'initialization' stamp: 'has 6/30/2013 19:08'!
initialize
	super initialize.
	file := WAFile new.! !

!UploadCourseware methodsFor: 'accessing' stamp: 'has 6/30/2013 19:01'!
receiveFile: aFile
    | stream |
    stream := (FileDirectory default directoryNamed: 'uploads')
		assureExistence;
		forceNewFileNamed: aFile fileName.
		file:= aFile.
		[ stream binary; nextPutAll: aFile rawContents ] 
		ensure: [ stream close ]! !

!UploadCourseware methodsFor: 'rendering' stamp: 'has 6/30/2013 19:02'!
renderContentOn: html
    html div: [
		html form multipart; with: [
        		html fileUpload
            		callback: [ :value | self receiveFile: value ].
        		html submitButton 
				callback: [self answer: file];
				with: 'Send File'.
			html cancelButton
			callback: [self answer: nil];
			with: 'Cancel'.
		].
	].! !

WAComponent subclass: #UserListView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!UserListView methodsFor: 'updating' stamp: 'oda 7/1/2013 17:48'!
blockUser: anUser
	| component answer userManager |
	component := ConfirmView on: 'Are you sure you want to block this user?'.
	answer := self call: component.

	(answer)
		ifTrue: [	
				userManager := UserManager new.
				[
					userManager blockUser: anUser.
					self inform: ('User successfully blocked.').
				]
				on: Error
				do: [:sig |
					OCMSDB session abort.
					self inform: ('Failed due to ', sig asString)
				].
		].
! !

!UserListView methodsFor: 'rendering' stamp: 'oda 7/1/2013 16:35'!
renderContentOn: html
	html heading
		level: 1;
		with: 'Users'.
	self renderItemsOn: html.  ! !

!UserListView methodsFor: 'rendering' stamp: 'oda 7/1/2013 18:24'!
renderItem: anUser on: html
	html tableRow: [
		html tableData: [
			html strong: anUser login.
		].
		html tableData: [
			anUser isAdmin ifTrue: [
				html text: 'Admin'.
			]
			ifFalse: [ anUser isEnabled ifTrue: [
				html anchor
					callback: [self blockUser: anUser];
					with: 'Block'.
			] ifFalse: [
				html anchor
					callback: [self unblockUser: anUser];
					with: 'Unblock'.
			]]  
		]  
	]! !

!UserListView methodsFor: 'rendering' stamp: 'oda 7/1/2013 16:35'!
renderItemsOn: html
	| userList |
	userList := Users getAll.
	html table: [
		userList do: [:each | self renderItem: each on: html].
	]! !

!UserListView methodsFor: 'updating' stamp: 'oda 7/1/2013 17:48'!
unblockUser: anUser
	| component answer userManager |
	component := ConfirmView on: 'Are you sure you want to unblock this user?'.
	answer := self call: component.

	(answer)
		ifTrue: [	
				userManager := UserManager new.
				[
					userManager unblockUser: anUser.
					self inform: ('User successfully unblocked.').
				]
				on: Error
				do: [:sig |
					OCMSDB session abort.
					self inform: ('Falied it due to ', sig asString)
				].
		].
! !

WAComponent subclass: #UserRegistrationView
	instanceVariableNames: 'user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!UserRegistrationView methodsFor: 'initialize-release' stamp: 'oda 6/29/2013 18:18'!
initialize
	super initialize.
	user := User new.! !

!UserRegistrationView methodsFor: 'rendering' stamp: 'oda 6/29/2013 18:39'!
renderButtonsOn: html
	html div: [
		html submitButton
			callback: [self answer: user];
			with: 'Register'.
		html cancelButton
			callback: [self answer: nil];
			with: 'Cancel'.
	].! !

!UserRegistrationView methodsFor: 'rendering' stamp: 'oda 6/29/2013 19:19'!
renderContentOn: html
	html heading level: 1; with: 'User Registration'.
	html text: 'Type your registration Info'. 
	
	html form: [
		self
			renderLoginOn: html;
			renderPasswordOn: html;
			renderUsernameOn: html;
			renderEmailOn: html;
			renderButtonsOn: html;  
			yourself.  
	].  ! !

!UserRegistrationView methodsFor: 'rendering' stamp: 'oda 6/29/2013 19:18'!
renderEmailOn: html
	html div: [
		html label: 'Email:'.
		html textInput
			callback: [:value | user email: value].
	].! !

!UserRegistrationView methodsFor: 'rendering' stamp: 'oda 6/29/2013 18:35'!
renderLoginOn: html
	html div: [
		html label: 'Login:'.
		html textInput
			callback: [:value | user login: value].
	].! !

!UserRegistrationView methodsFor: 'rendering' stamp: 'oda 6/30/2013 21:42'!
renderPasswordOn: html
	html div: [
		html label: 'Password:'.
		html passwordInput
			callback: [:value | user password: value hash].
	].! !

!UserRegistrationView methodsFor: 'rendering' stamp: 'oda 6/29/2013 19:18'!
renderUsernameOn: html
	html div: [
		html label: 'Name:'.
		html textInput
			callback: [:value | user username: value].
	].! !

WAFileLibrary subclass: #OCMSFileLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!OCMSFileLibrary methodsFor: 'as yet unclassified' stamp: 'oda 7/1/2013 15:40'!
ocmsCss
^'body {
	font-family: 			Georgia, "Times New Roman", Times, serif;
	font-size: 			small;
}
#allcontent {
	width: 				860px;
	padding-top: 		5px;
	padding-bottom: 	5px;
	background-color: 	#fff0d0;
	margin-left: 		auto;
	margin-right: 		auto;
}
*.section {
	background-color: 	#ffeabf;
}
#header {
	margin: 				10px;
}
#main {
	padding: 			15px;
	margin: 				0px 10px 10px 10px;
	width: 				600px;
	float: 				right;
}
#sidebar {
	padding: 			15px;
	margin: 				0px 650px 10px 10px;
}
#footer {
	color: 				#204670;
	text-align: 			center;
	padding: 			15px;
	margin: 				10px;
	clear: 				right;
}'! !

WASession subclass: #OCMSSession
	instanceVariableNames: 'user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!OCMSSession methodsFor: 'accessing' stamp: 'oda 6/29/2013 20:42'!
user
	^user! !

!OCMSSession methodsFor: 'accessing' stamp: 'oda 6/29/2013 22:23'!
user: anUser
	user := anUser.! !
OCMSHome initialize!
